#
# spec file for package yaz (Version 2.0.28)
#
# Copyright (c) 2004 SUSE LINUX AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# norootforbuild
# neededforbuild  expat openssl openssl-devel readline-devel tcpd tcpd-devel

BuildRequires: aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv less libacl libattr libgcc libnscd libselinux libstdc++ libxcrypt libzio m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch permissions popt procinfo procps psmisc pwdutils rcs readline sed strace syslogd sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel autoconf automake binutils expat gcc gdbm gettext libtool openssl-devel perl readline-devel rpm tcpd-devel

Name:         yaz
Version:      2.0.28
Release:      0.1
License:      BSD, Other License(s), see package
Group:        Development/Libraries/C and C++
Source:       http://ftp.indexdata.dk/pub/yaz/%{name}-%{version}.tar.gz
BuildRoot:    %{_tmppath}/%{name}-%{version}-build
URL:          http://www.indexdata.dk/yaz/
Summary:      Z39.50 Programs
# PreReq: expat

%description
This package contains both a test-server and clients (normal & ssl) for
the ANSI/NISO Z39.50 protocol for Information Retrieval.



Authors:
--------
    Adam Dickmeiss <adam@indexdata.dk>

%package -n libyaz
Summary:      Z39.50 Library
Group:        Development/Libraries/C and C++
# Requires: libxml2 openssl

%description -n libyaz
YAZ is a C library for developing client - and server applications
using the ANSI/NISO Z39.50 protocol for Information Retrieval.



Authors:
--------
    Adam Dickmeiss <adam@indexdata.dk>

%package -n libyaz-devel
Summary:      Z39.50 Library
Group:        Development/Libraries/C and C++
Requires:     libyaz = %{version}

%description -n libyaz-devel
YAZ is a C library for developing client - and server applications
using the ANSI/NISO Z39.50 protocol for Information Retrieval.



Authors:
--------
    Adam Dickmeiss <adam@indexdata.dk>

%prep
%setup -q

%build
#  --with-dsssl=/usr/share/sgml/docbook/dsssl-stylesheets \
#  --with-dtd=/usr/share/sgml/db41xml
CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing" \
  ./configure --prefix=%{_prefix} --libdir=%_libdir --mandir=%{_mandir} \
  --enable-shared --enable-tcpd --with-openssl
make

%install
rm -fr ${RPM_BUILD_ROOT}
make DESTDIR=${RPM_BUILD_ROOT} install
pushd doc
  # make prefix=${RPM_BUILD_ROOT}/usr install
  make DESTDIR=${RPM_BUILD_ROOT} install
popd
# Unwanted doc stuff
rm -fr $RPM_BUILD_ROOT%{_datadir}/doc
rm -fr html
mkdir html
cp -a doc/*.html html
cp doc/*pdf .
ln -sf introduction.html html/index.html
%define DOCFILES README LICENSE NEWS TODO yaz.pdf
{
  echo "<html><head><title>%{name} documentation directory</title></head>"
  echo "<body><ul>"
  echo "<li><a href=\"html/index.html\">%{name}</a>, official documentation (local)"
  for f in %{DOCFILES} http://www.indexdata.dk/links/  ; do
    if [ "http:" = "${f%%%%/*}" ]; then
      echo "<li><a href=\"$f\">$f</a>"
      continue
    fi
    [ -f $f ] || continue
    echo "<li><a href=\"$f\">$f</a>"
  done
  echo "</li></body></html>"
} >index.html
/sbin/ldconfig -n $RPM_BUILD_ROOT%{_libdir}

%clean
rm -fr ${RPM_BUILD_ROOT}

%post
%run_ldconfig

%postun
%run_ldconfig

%files
%defattr(-,root,root)
%{_bindir}/yaz-client*
%{_bindir}/yaz-ztest*
%{_bindir}/yaz-iconv
%{_bindir}/yaz-marcdump
%{_bindir}/zoomsh
%{_mandir}/*/yaz-client.*
%{_mandir}/*/zoomsh.*
%{_mandir}/*/yaz-ztest.*
%{_mandir}/*/yaz-iconv.*
%{_mandir}/*/yaz-marcdump.*

%files -n libyaz
%defattr(-,root,root)
%doc %{DOCFILES}
%doc index.html html
%doc doc/yaz.pdf
%{_libdir}/*.so.*
%{_mandir}/*/yaz.*
%dir %{_datadir}/yaz
%{_datadir}/yaz/etc

%files -n libyaz-devel
%defattr(-,root,root)
%{_bindir}/yaz-config
%{_bindir}/yaz-asncomp
%{_includedir}/yaz
%{_libdir}/*.so
%{_libdir}/*.a
%{_libdir}/*.la
%{_datadir}/yaz/z39.50
%{_datadir}/yaz/ill
%{_datadir}/aclocal/yaz.m4
%{_mandir}/man8/yaz-config.*
%{_mandir}/man1/yaz-asncomp.*

%changelog -n yaz
* Tue Nov 16 2004 - ke@suse.de
- Update to version 2.0.28; changes since 2.0.26:
  * Various bug fixes.
  * Improve documentation.
- Add tcpd and tcpd-devel to neededforbuild.
* Fri Oct 08 2004 - ke@suse.de
- Update to version 2.0.26; changes since 2.0.22:
  * Various bug fixes.
  * Add YAZ GFS support for conversion from Z39.50 surrogate diagnostics
  to SRW surrogate diagnostics.
  * Fixes for MARC-8 in yaz_iconv character set utilies. The MARC-8
  to UTF-8/UCS conversion is now only based on codetables.xml.
* Mon Aug 09 2004 - ke@suse.de
- Update to version 2.0.22; changes:
  * Add support for more "commit changes" in ZOOM (uses Extended
  Services).
  * For yaz-client, command set_marcdump <file> / -m <file> dumps
  SUTRS/XML/.. records as well.
* Fri May 28 2004 - ke@suse.de
- Update to version 2.0.21; changes:
  * SSL comstack now uses yaz.pem certificate file on server side
  by default. Certificate filename can be configured by calling
  comstack function cs_set_ssl_certificate_file before cs_bind is used.
  * Fix bug regarding multiple calls to ZOOM_connection_connect.
  * Implement cs_set_ssl_ctx which sets SSL_CTX for SSL comstack.
  * Do not create SSL_CTX in cs_create (ssl_type). Create in tcpip_bind,
  tcpip_rcvconnect instead. This allows user to set custom SSL_CTX.
  * ZOOM now allows inspection of X509 peer certificate for verification.
  The X509 buffer is retrived by reading ZOOM option "sslPeerCert".
  * Remove libyazssl.la. When SSL is enabled, libyaz.la has SSL support and
  all programs have too (yaz-ztest, yaz-client, zoom..).
  * Documentation about MARC decoding tools.
  * Fix encoding of xsd:string to use text instead of CDATA.
  * Fix endless loop in CQL parser with unbalanced ".
  * Use a more compact way to store MARC-8 conversion tables.
  * Fix a bug in yaz_iconv regarding conversion to UCS4 / UCS4LE.
  * Update CQL parser to use new CQL 1.1 modifiers for booleans and
  relations.
  * Another fix for decoding of XML packed records.
  * Fixes for Chunked encoding. White space not ignored after length spec.
  * Implement chunked HTTP transfer.
* Wed May 12 2004 - ro@suse.de
- added -fno-strict-aliasing
* Tue Feb 17 2004 - ke@suse.de
- Update to version 2.0.12; changes:
  * Various enhancements to yaz-client.
  * Fix various bugs (encoding related, memory leak, etc.).
  * Fix compilation for SSL which wasn't properly enabled for all
  platforms.
  * MARC conversion can now generate ISO2709 output in another
  character set.
  * ZOOM-C enhancements.
  * New utilities: yaz-iconv and yaz-marcdump.
  * Enhancements to the generic front-end server.
* Sat Jan 10 2004 - adrian@suse.de
- add %%defattr and %%run_ldconfig
* Thu Oct 16 2003 - ke@suse.de
- Update to version 2.0.4; changes:
- Allow any CQL relation (not just all,any,exact,scr).
- Fixes for OCLC UI ASN.1 to make it work with SilverPlatter targets
  that features the same UI.
- Implement command update0 in YAZ client which is equivalent to
  update but uses old of Ext Update ASN.1.
- Use OID 1.2.840.10003.15.1000.81.1 for privately defined charsets
  in charset negotiation. Added VAL_ID_CHARSET in oid.h.
  Previously no OID was used for this info.
- ZOOM uses smallSetUpperBound=1 instead of 0 for piggyback searches.
  It apparantely upsets EBSCO Publishing IR Z39.50 Server which
  returns 'malformed search term' otherwise.
- SortResponse member resultCount now set to NULL in sort handler of
  frontend server.
- OPAC support ZOOM. ZOOM_record_get returns OPAC info (as XML) if
  type is "opac".
- Add three new utility functions for translating OIDs between various
  formats -- symbolic name such as "Usmarc", minus-1-terminated int
  arrays and dotted strings such as "1.2.840.10003.9.5.1".
- Revert modifications for ES Update definition for z_IU0Update
  (OID 1.2.840.10003.9.5.1 and 1.2.840.10003.9.5). The definition
  is back to YAZ 2.0.2.
- String value attributes for CCL parser.
- Support for OCLC's locally registered "OCLC-UserInformation" PDU,
  which their FirstSearch server returns in Init responses, sometimes
  carrying useful diagnostic information when Init fails.  This has the
  OID 1.2.840.10003.10.1000.17.1 and is defined in the file
  "z39.50/oclcui.asn", where its definition is somewhat different from
  what OCLC document on their web-site, as required to interoperate with
  their servers.
- Support for anonymous authentication in yaz-client.  Use the command
  "auth -".
- Fix the OID of the Index Data-local "admin" Extended Service from
  1.2.840.10003.9.81.1 to 1.2.840.10003.9.1000.81.1.  The omission of
  the 1000, which indicates a locally-defined OID, was a mistake.
* Mon Jun 23 2003 - ke@suse.de
- Update to version 2.0.3; changes:
- Fix CCL directive @case handling so that it affects string match for
  both CCL keywords and qualifiers.
- * ESFormat-Update updates. Packages with OID 1.2.840.10003.9.5.1 and
  1.2.840.10003.9.5 are now handled by the same decoder z_IU0Update .
  Decoder has been updated with ASN.1 changes as listed in
  http://lcweb.loc.gov/z3950/agency/defns/updateES.html
- ZOOM_record_get may now return a record in a specific character set.
  For type use "form; charset=from[,to]" where form (render, xml, ..),
  "from" is the character set of record as returned by target. "to" is
  the character set to be returned. If omitted, "to" is UTF-8.
- YAZ ASN.1 compiler renamed from yaz-comp to yaz-asncomp
- New ODR utility, odr_getelement, which returns name of element for
  which encoding/decoding failed.
- Fixed ODR so that it returns error code OREQUIRED rather than ONONE
  in cases where a required element was omitted.
- Bug fix: some MARC8 sequences were not converted.
- New ZOOM option "step" which specifies number of records to be
  retrieved in one chunk. Used in conjunction with "start" and "count".
- SRW support for yaz-client. Use scheme http: to use it, e.g.
  http://host:port/db
- yaz-client no longer does (un)intelligent character set conversions
  by default. Can be enabled with charset and marc_charset commands.
- New function, cql_strerror() translates SRW error codes, as returned
  by cql_transform_error(), into human-readable English strings.  Used
  in yaz-client diagnostics when appropriate.
- New CQL2RPN query-type for the command-line yaz-client, parses CQL and
  converts it into a type-1 query which is sent to the server.  This
  makes CQL available for use with all Z-servers, as opposed to the tiny
  minority that can handle CQL queries themselves.
* Thu Jun 12 2003 - kukuk@suse.de
- Add missing directory to filelist
* Mon May 26 2003 - ke@suse.de
- Remove unwanted files from $RPM_BUILD_ROOT.
* Thu May 22 2003 - ke@suse.de
- Split subpackage libyaz into libyaz and libyaz-devel.
* Thu May 22 2003 - ke@suse.de
- Update to version 2.0.2; changes:
- New ZOOM events ZOOM_EVENT_RECV_{RECORD,SEARCH} for receiving a record
  and search result respectively.
- New member 'schema' in struct bend_fetch_rr which the name of requested
  schema (SRW/SRU) for record (or NULL if none was given). The fetch
  handler MAY set this to reflect the schema of the returned record.
- New member 'display_term' in struct scan_entry. GFS now sets member entries
  and allocates scan entries to be filled by user scan handler. In previous
  version, entries member was allocated by the scan handler. That still
  works,  but the GFS will ignore member display_term - assuming it was NOT
  set by the handler. The fact that the GFS now allocates the entries both
  allows for new members and makes a scan handler easier to write.
- SRW/SRU recordPacking. For SRW default recordPacking is string. For
  SRU default recordPacking is string.
- SRU protocol support for frontend server.
- Add missing PQF transform rules for <= and >= .
- Added scan for the ZOOM shell (zoomsh).
- Bugfix: CQL lex buffer overflow.
- Split package into yaz and libyaz.
* Wed Mar 26 2003 - ke@suse.de
- Update to version 2.0; changes:
  Possible compatibility problems with earlier versions marked with '*'.
- * String Identifers for Schemas (Amendment 5).
  http://lcweb.loc.gov/z3950/agency/amend/am5.html
- * resultCount parameter to Sort Response (Amendment 1).
  http://lcweb.loc.gov/z3950/agency/amend/am1.html
- Support for SRW 1.0 over HTTP. This is an optional feature and
  requires libxml2 to operate. Enable SOAP by specifying --with-xml2
  for configure (not enabled on SuSE Linux).
- Generic frontend server supports HTTP/SOAP/SRW and Z39.50/BER
  on the same port.  SRW SearchRetrieveRequests are mapped
  to bend_init,bend_search,bend_fetch,bend_close.
- Add Z39.50 Query Type-104 - to facilitate CQL within Z39.50.
- CQL support. Source is directory 'cql'. CQL is supported in ZOOM
  (both SRW and Z39.50) and the YAZ client (Z39.50 only).
- ZOOM connections are SRW based if schem http is used for hostname
  in connect, e.g.  z = ZOOM_connection_new("http://myserver");
  ZOOM_query may be of type CQL, e.g. ZOOM_query_cql(q, "dc.title=x");
- CCL proximity operators !n, %%n converts to PQF @prox 0 n 1 2 k 2
  and @prox 0 n 0 1 k 2 respectively, meaning: exlusion=false,
  distance=n, order=true/false, relation=le, prox unit=word. If
  n is omitted, distance 1 is used.
- New MARC decode API. All new functions operate on a yaz_marc_t
  handle. The most important new functions are: yaz_marc_create,
  yaz_marc_decode_{buf,wrbuf}, yaz_marc_destroy, .. to create handler,
  decode and destroy respectively. Decoder can produce formats
  MARC line, simple XML, OAI MARC and MARC XML (LoC). See
  include/yaz/marcdisp.h.
- YAZ Iconv utility now supports MARC8 decoding (marc8.c). Converts
  to UTF-8, UCS-32, wchar_t or Latin-1.
- * Prototypes for yaz_iconv_-functions moved to separate header
  include/yaz/yaz-iconv.h.
- Make a few private functions 'static' in unix.c. This prevents
  duplicate unix_close in PHP with YAZ and imap. PHP Bug 20977.
- For ZOOM connection, the options targetImplementation{Id,Name,Version}
  are set when Init Response is received.
- New function ZOOM_connection_error_x similar to ZOOM_connection_error
  but returns diagnostic set as well.
- New function yaz_strerror which is a portable wrapper for
  strerror/strerror_r/GetLastMessage.
- * ZOOM_record_get supports type "xml" in which case MARC XML (from LOC)
  is returned for MARC. If type is "oai", then OAI MARC is returned.
* Fri Nov 29 2002 - ke@suse.de
- Update to version 1.9.2; changes:
  * yaz_marc_decode uses OAI MARC as XML format for ISO2709 records.
  * Fix bad race conditions on SIGTERM and terminate gracefully in
  frontend server.
  * Move retrieval (data1) module to Zebra (now package "idzebra").
  * Add GRS-1 render for ZOOM using same format as yaz-client.
* Fri Nov 22 2002 - ke@suse.de
- Update to version 1.9.1; changes since 1.8.8:
  * Add man pages: yaz-client(1), yaz-ztest(8), yaz(7), zoomsh(1).
  * Bugfixes: ESpec handling in data1 module; handle PDU encoding
  failures properly; ZOOM_record_get for type "database"; ZOOM C
  record cache so that preferredRecordSyntax and elementSetName is
  used to check for already fetched records.
  * SGML reader parses comments and makes them part of the data1 tree.
  * Add more Bib-1 diagnostics (approved extensions).
  * PQF parser rejects bad queries - including those with extra
  characters in them. PQF parser used to silently ignore that.
  Cleaner API for PQF added, which allows you to get detailed
  error information for bad queries (see yaz/pquery.h).
  * Use iconv.
  * Remov XML reader (d1_expat.c). It's part of Zebra instead.
* Mon Aug 05 2002 - ke@suse.de
- Update to version 1.8.8:
  * Bug fixes.
  * Modify data1 to handle XML and character set encodings.
  * New COMSTACK type: local UNIX socket. It's useful if you have
  a local service and/or want extreme performance.
- Add expat and readline-devel to #neededforbuild to link against expat
  and readline.
* Mon May 27 2002 - ke@suse.de
- Update to version 1.8.7:
- Bug fixes.
- Better i18n support (ZOOM API and YAZ client).
* Wed May 08 2002 - ke@suse.de
- Use %%_libdir macro.
* Mon Apr 08 2002 - ke@suse.de
- Update to version 1.8.6.
* Mon Mar 11 2002 - ke@suse.de
- New package: version 1.8.5.
